t / test-lib.shon commit Merge branch 'jc/maint-pull-docfix-for-409b8d82' into jc/maint-pull-docfix (8be1d04)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Keep the original TERM for say_color
  19ORIGINAL_TERM=$TERM
  20
  21# Test the binaries we have just built.  The tests are kept in
  22# t/ subdirectory and are run in 'trash directory' subdirectory.
  23if test -z "$TEST_DIRECTORY"
  24then
  25        # We allow tests to override this, in case they want to run tests
  26        # outside of t/, e.g. for running tests on the test library
  27        # itself.
  28        TEST_DIRECTORY=$(pwd)
  29fi
  30if test -z "$TEST_OUTPUT_DIRECTORY"
  31then
  32        # Similarly, override this to store the test-results subdir
  33        # elsewhere
  34        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  35fi
  36GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  37
  38################################################################
  39# It appears that people try to run tests without building...
  40"$GIT_BUILD_DIR/git" >/dev/null
  41if test $? != 1
  42then
  43        echo >&2 'error: you do not seem to have built git yet.'
  44        exit 1
  45fi
  46
  47. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  48export PERL_PATH SHELL_PATH
  49
  50# if --tee was passed, write the output not only to the terminal, but
  51# additionally to the file test-results/$BASENAME.out, too.
  52case "$GIT_TEST_TEE_STARTED, $* " in
  53done,*)
  54        # do not redirect again
  55        ;;
  56*' --tee '*|*' --va'*)
  57        mkdir -p test-results
  58        BASE=test-results/$(basename "$0" .sh)
  59        (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
  60         echo $? > $BASE.exit) | tee $BASE.out
  61        test "$(cat $BASE.exit)" = 0
  62        exit
  63        ;;
  64esac
  65
  66# For repeatability, reset the environment to known value.
  67LANG=C
  68LC_ALL=C
  69PAGER=cat
  70TZ=UTC
  71TERM=dumb
  72export LANG LC_ALL PAGER TERM TZ
  73EDITOR=:
  74# A call to "unset" with no arguments causes at least Solaris 10
  75# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  76# deriving from the command substitution clustered with the other
  77# ones.
  78unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
  79        my @env = keys %ENV;
  80        my $ok = join("|", qw(
  81                TRACE
  82                DEBUG
  83                USE_LOOKUP
  84                TEST
  85                .*_TEST
  86                PROVE
  87                VALGRIND
  88                UNZIP
  89                PERF_
  90        ));
  91        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  92        print join("\n", @vars);
  93')
  94unset XDG_CONFIG_HOME
  95GIT_AUTHOR_EMAIL=author@example.com
  96GIT_AUTHOR_NAME='A U Thor'
  97GIT_COMMITTER_EMAIL=committer@example.com
  98GIT_COMMITTER_NAME='C O Mitter'
  99GIT_MERGE_VERBOSITY=5
 100GIT_MERGE_AUTOEDIT=no
 101export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 102export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 103export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 104export EDITOR
 105
 106# Add libc MALLOC and MALLOC_PERTURB test
 107# only if we are not executing the test with valgrind
 108if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 109   test -n "$TEST_NO_MALLOC_CHECK"
 110then
 111        setup_malloc_check () {
 112                : nothing
 113        }
 114        teardown_malloc_check () {
 115                : nothing
 116        }
 117else
 118        setup_malloc_check () {
 119                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 120                export MALLOC_CHECK_ MALLOC_PERTURB_
 121        }
 122        teardown_malloc_check () {
 123                unset MALLOC_CHECK_ MALLOC_PERTURB_
 124        }
 125fi
 126
 127# Protect ourselves from common misconfiguration to export
 128# CDPATH into the environment
 129unset CDPATH
 130
 131unset GREP_OPTIONS
 132unset UNZIP
 133
 134case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1351|2|true)
 136        echo "* warning: Some tests will not work if GIT_TRACE" \
 137                "is set as to trace on STDERR ! *"
 138        echo "* warning: Please set GIT_TRACE to something" \
 139                "other than 1, 2 or true ! *"
 140        ;;
 141esac
 142
 143# Convenience
 144#
 145# A regexp to match 5 and 40 hexdigits
 146_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 147_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 148
 149# Zero SHA-1
 150_z40=0000000000000000000000000000000000000000
 151
 152# Line feed
 153LF='
 154'
 155
 156export _x05 _x40 _z40 LF
 157
 158# Each test should start with something like this, after copyright notices:
 159#
 160# test_description='Description of this test...
 161# This test checks if command xyzzy does the right thing...
 162# '
 163# . ./test-lib.sh
 164[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 165                TERM=$ORIGINAL_TERM &&
 166                export TERM &&
 167                [ -t 1 ] &&
 168                tput bold >/dev/null 2>&1 &&
 169                tput setaf 1 >/dev/null 2>&1 &&
 170                tput sgr0 >/dev/null 2>&1
 171        ) &&
 172        color=t
 173
 174while test "$#" -ne 0
 175do
 176        case "$1" in
 177        -d|--d|--de|--deb|--debu|--debug)
 178                debug=t; shift ;;
 179        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 180                immediate=t; shift ;;
 181        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 182                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 183        -h|--h|--he|--hel|--help)
 184                help=t; shift ;;
 185        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 186                verbose=t; shift ;;
 187        -q|--q|--qu|--qui|--quie|--quiet)
 188                # Ignore --quiet under a TAP::Harness. Saying how many tests
 189                # passed without the ok/not ok details is always an error.
 190                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 191        --with-dashes)
 192                with_dashes=t; shift ;;
 193        --no-color)
 194                color=; shift ;;
 195        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 196                valgrind=t; verbose=t; shift ;;
 197        --tee)
 198                shift ;; # was handled already
 199        --root=*)
 200                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 201                shift ;;
 202        *)
 203                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 204        esac
 205done
 206
 207if test -n "$color"
 208then
 209        say_color () {
 210                (
 211                TERM=$ORIGINAL_TERM
 212                export TERM
 213                case "$1" in
 214                error)
 215                        tput bold; tput setaf 1;; # bold red
 216                skip)
 217                        tput setaf 4;; # blue
 218                warn)
 219                        tput setaf 3;; # brown/yellow
 220                pass)
 221                        tput setaf 2;; # green
 222                info)
 223                        tput setaf 6;; # cyan
 224                *)
 225                        test -n "$quiet" && return;;
 226                esac
 227                shift
 228                printf "%s" "$*"
 229                tput sgr0
 230                echo
 231                )
 232        }
 233else
 234        say_color() {
 235                test -z "$1" && test -n "$quiet" && return
 236                shift
 237                printf "%s\n" "$*"
 238        }
 239fi
 240
 241error () {
 242        say_color error "error: $*"
 243        GIT_EXIT_OK=t
 244        exit 1
 245}
 246
 247say () {
 248        say_color info "$*"
 249}
 250
 251test "${test_description}" != "" ||
 252error "Test script did not set test_description."
 253
 254if test "$help" = "t"
 255then
 256        echo "$test_description"
 257        exit 0
 258fi
 259
 260exec 5>&1
 261exec 6<&0
 262if test "$verbose" = "t"
 263then
 264        exec 4>&2 3>&1
 265else
 266        exec 4>/dev/null 3>/dev/null
 267fi
 268
 269test_failure=0
 270test_count=0
 271test_fixed=0
 272test_broken=0
 273test_success=0
 274
 275test_external_has_tap=0
 276
 277die () {
 278        code=$?
 279        if test -n "$GIT_EXIT_OK"
 280        then
 281                exit $code
 282        else
 283                echo >&5 "FATAL: Unexpected exit with code $code"
 284                exit 1
 285        fi
 286}
 287
 288GIT_EXIT_OK=
 289trap 'die' EXIT
 290
 291# The user-facing functions are loaded from a separate file so that
 292# test_perf subshells can have them too
 293. "$TEST_DIRECTORY/test-lib-functions.sh"
 294
 295# You are not expected to call test_ok_ and test_failure_ directly, use
 296# the text_expect_* functions instead.
 297
 298test_ok_ () {
 299        test_success=$(($test_success + 1))
 300        say_color "" "ok $test_count - $@"
 301}
 302
 303test_failure_ () {
 304        test_failure=$(($test_failure + 1))
 305        say_color error "not ok $test_count - $1"
 306        shift
 307        echo "$@" | sed -e 's/^/#       /'
 308        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 309}
 310
 311test_known_broken_ok_ () {
 312        test_fixed=$(($test_fixed+1))
 313        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 314}
 315
 316test_known_broken_failure_ () {
 317        test_broken=$(($test_broken+1))
 318        say_color warn "not ok $test_count - $@ # TODO known breakage"
 319}
 320
 321test_debug () {
 322        test "$debug" = "" || eval "$1"
 323}
 324
 325test_eval_ () {
 326        # This is a separate function because some tests use
 327        # "return" to end a test_expect_success block early.
 328        eval </dev/null >&3 2>&4 "$*"
 329}
 330
 331test_run_ () {
 332        test_cleanup=:
 333        expecting_failure=$2
 334        test_eval_ "$1"
 335        eval_ret=$?
 336
 337        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 338        then
 339                setup_malloc_check
 340                test_eval_ "$test_cleanup"
 341                teardown_malloc_check
 342        fi
 343        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 344        then
 345                echo ""
 346        fi
 347        return "$eval_ret"
 348}
 349
 350test_skip () {
 351        test_count=$(($test_count+1))
 352        to_skip=
 353        for skp in $GIT_SKIP_TESTS
 354        do
 355                case $this_test.$test_count in
 356                $skp)
 357                        to_skip=t
 358                        break
 359                esac
 360        done
 361        if test -z "$to_skip" && test -n "$test_prereq" &&
 362           ! test_have_prereq "$test_prereq"
 363        then
 364                to_skip=t
 365        fi
 366        case "$to_skip" in
 367        t)
 368                of_prereq=
 369                if test "$missing_prereq" != "$test_prereq"
 370                then
 371                        of_prereq=" of $test_prereq"
 372                fi
 373
 374                say_color skip >&3 "skipping test: $@"
 375                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 376                : true
 377                ;;
 378        *)
 379                false
 380                ;;
 381        esac
 382}
 383
 384# stub; perf-lib overrides it
 385test_at_end_hook_ () {
 386        :
 387}
 388
 389test_done () {
 390        GIT_EXIT_OK=t
 391
 392        if test -z "$HARNESS_ACTIVE"
 393        then
 394                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 395                mkdir -p "$test_results_dir"
 396                base=${0##*/}
 397                test_results_path="$test_results_dir/${base%.sh}-$$.counts"
 398
 399                cat >>"$test_results_path" <<-EOF
 400                total $test_count
 401                success $test_success
 402                fixed $test_fixed
 403                broken $test_broken
 404                failed $test_failure
 405
 406                EOF
 407        fi
 408
 409        if test "$test_fixed" != 0
 410        then
 411                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
 412        fi
 413        if test "$test_broken" != 0
 414        then
 415                say_color warn "# still have $test_broken known breakage(s)"
 416        fi
 417        if test "$test_broken" != 0 || test "$test_fixed" != 0
 418        then
 419                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
 420                msg="remaining $test_remaining test(s)"
 421        else
 422                test_remaining=$test_count
 423                msg="$test_count test(s)"
 424        fi
 425        case "$test_failure" in
 426        0)
 427                # Maybe print SKIP message
 428                if test -n "$skip_all" && test $test_count -gt 0
 429                then
 430                        error "Can't use skip_all after running some tests"
 431                fi
 432                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 433
 434                if test $test_external_has_tap -eq 0
 435                then
 436                        if test $test_remaining -gt 0
 437                        then
 438                                say_color pass "# passed all $msg"
 439                        fi
 440                        say "1..$test_count$skip_all"
 441                fi
 442
 443                test -d "$remove_trash" &&
 444                cd "$(dirname "$remove_trash")" &&
 445                rm -rf "$(basename "$remove_trash")"
 446
 447                test_at_end_hook_
 448
 449                exit 0 ;;
 450
 451        *)
 452                if test $test_external_has_tap -eq 0
 453                then
 454                        say_color error "# failed $test_failure among $msg"
 455                        say "1..$test_count"
 456                fi
 457
 458                exit 1 ;;
 459
 460        esac
 461}
 462
 463if test -n "$valgrind"
 464then
 465        make_symlink () {
 466                test -h "$2" &&
 467                test "$1" = "$(readlink "$2")" || {
 468                        # be super paranoid
 469                        if mkdir "$2".lock
 470                        then
 471                                rm -f "$2" &&
 472                                ln -s "$1" "$2" &&
 473                                rm -r "$2".lock
 474                        else
 475                                while test -d "$2".lock
 476                                do
 477                                        say "Waiting for lock on $2."
 478                                        sleep 1
 479                                done
 480                        fi
 481                }
 482        }
 483
 484        make_valgrind_symlink () {
 485                # handle only executables, unless they are shell libraries that
 486                # need to be in the exec-path.  We will just use "#!" as a
 487                # guess for a shell-script, since we have no idea what the user
 488                # may have configured as the shell path.
 489                test -x "$1" ||
 490                test "#!" = "$(head -c 2 <"$1")" ||
 491                return;
 492
 493                base=$(basename "$1")
 494                symlink_target=$GIT_BUILD_DIR/$base
 495                # do not override scripts
 496                if test -x "$symlink_target" &&
 497                    test ! -d "$symlink_target" &&
 498                    test "#!" != "$(head -c 2 < "$symlink_target")"
 499                then
 500                        symlink_target=../valgrind.sh
 501                fi
 502                case "$base" in
 503                *.sh|*.perl)
 504                        symlink_target=../unprocessed-script
 505                esac
 506                # create the link, or replace it if it is out of date
 507                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 508        }
 509
 510        # override all git executables in TEST_DIRECTORY/..
 511        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 512        mkdir -p "$GIT_VALGRIND"/bin
 513        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 514        do
 515                make_valgrind_symlink $file
 516        done
 517        # special-case the mergetools loadables
 518        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 519        OLDIFS=$IFS
 520        IFS=:
 521        for path in $PATH
 522        do
 523                ls "$path"/git-* 2> /dev/null |
 524                while read file
 525                do
 526                        make_valgrind_symlink "$file"
 527                done
 528        done
 529        IFS=$OLDIFS
 530        PATH=$GIT_VALGRIND/bin:$PATH
 531        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 532        export GIT_VALGRIND
 533elif test -n "$GIT_TEST_INSTALLED"
 534then
 535        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 536        error "Cannot run git from $GIT_TEST_INSTALLED."
 537        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 538        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 539else # normal case, use ../bin-wrappers only unless $with_dashes:
 540        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 541        if ! test -x "$git_bin_dir/git"
 542        then
 543                if test -z "$with_dashes"
 544                then
 545                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 546                fi
 547                with_dashes=t
 548        fi
 549        PATH="$git_bin_dir:$PATH"
 550        GIT_EXEC_PATH=$GIT_BUILD_DIR
 551        if test -n "$with_dashes"
 552        then
 553                PATH="$GIT_BUILD_DIR:$PATH"
 554        fi
 555fi
 556GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 557unset GIT_CONFIG
 558GIT_CONFIG_NOSYSTEM=1
 559GIT_ATTR_NOSYSTEM=1
 560export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 561
 562if test -z "$GIT_TEST_CMP"
 563then
 564        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 565        then
 566                GIT_TEST_CMP="$DIFF -c"
 567        else
 568                GIT_TEST_CMP="$DIFF -u"
 569        fi
 570fi
 571
 572GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 573export GITPERLLIB
 574test -d "$GIT_BUILD_DIR"/templates/blt || {
 575        error "You haven't built things yet, have you?"
 576}
 577
 578if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 579then
 580        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 581        export GITPYTHONLIB
 582        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 583                error "You haven't built git_remote_helpers yet, have you?"
 584        }
 585fi
 586
 587if ! test -x "$GIT_BUILD_DIR"/test-chmtime
 588then
 589        echo >&2 'You need to build test-chmtime:'
 590        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 591        exit 1
 592fi
 593
 594# Test repository
 595TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
 596test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 597case "$TRASH_DIRECTORY" in
 598/*) ;; # absolute path is good
 599 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 600esac
 601test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 602rm -fr "$TRASH_DIRECTORY" || {
 603        GIT_EXIT_OK=t
 604        echo >&5 "FATAL: Cannot prepare test area"
 605        exit 1
 606}
 607
 608HOME="$TRASH_DIRECTORY"
 609export HOME
 610
 611if test -z "$TEST_NO_CREATE_REPO"
 612then
 613        test_create_repo "$TRASH_DIRECTORY"
 614else
 615        mkdir -p "$TRASH_DIRECTORY"
 616fi
 617# Use -P to resolve symlinks in our working directory so that the cwd
 618# in subprocesses like git equals our $PWD (for pathname comparisons).
 619cd -P "$TRASH_DIRECTORY" || exit 1
 620
 621this_test=${0##*/}
 622this_test=${this_test%%-*}
 623for skp in $GIT_SKIP_TESTS
 624do
 625        case "$this_test" in
 626        $skp)
 627                say_color info >&3 "skipping test $this_test altogether"
 628                skip_all="skip all tests in $this_test"
 629                test_done
 630        esac
 631done
 632
 633# Provide an implementation of the 'yes' utility
 634yes () {
 635        if test $# = 0
 636        then
 637                y=y
 638        else
 639                y="$*"
 640        fi
 641
 642        while echo "$y"
 643        do
 644                :
 645        done
 646}
 647
 648# Fix some commands on Windows
 649case $(uname -s) in
 650*MINGW*)
 651        # Windows has its own (incompatible) sort and find
 652        sort () {
 653                /usr/bin/sort "$@"
 654        }
 655        find () {
 656                /usr/bin/find "$@"
 657        }
 658        sum () {
 659                md5sum "$@"
 660        }
 661        # git sees Windows-style pwd
 662        pwd () {
 663                builtin pwd -W
 664        }
 665        # no POSIX permissions
 666        # backslashes in pathspec are converted to '/'
 667        # exec does not inherit the PID
 668        test_set_prereq MINGW
 669        test_set_prereq NOT_CYGWIN
 670        test_set_prereq SED_STRIPS_CR
 671        ;;
 672*CYGWIN*)
 673        test_set_prereq POSIXPERM
 674        test_set_prereq EXECKEEPSPID
 675        test_set_prereq NOT_MINGW
 676        test_set_prereq CYGWIN
 677        test_set_prereq SED_STRIPS_CR
 678        ;;
 679*)
 680        test_set_prereq POSIXPERM
 681        test_set_prereq BSLASHPSPEC
 682        test_set_prereq EXECKEEPSPID
 683        test_set_prereq NOT_MINGW
 684        test_set_prereq NOT_CYGWIN
 685        ;;
 686esac
 687
 688( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
 689test -z "$NO_PERL" && test_set_prereq PERL
 690test -z "$NO_PYTHON" && test_set_prereq PYTHON
 691test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
 692test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
 693
 694# Can we rely on git's output in the C locale?
 695if test -n "$GETTEXT_POISON"
 696then
 697        GIT_GETTEXT_POISON=YesPlease
 698        export GIT_GETTEXT_POISON
 699        test_set_prereq GETTEXT_POISON
 700else
 701        test_set_prereq C_LOCALE_OUTPUT
 702fi
 703
 704# Use this instead of test_cmp to compare files that contain expected and
 705# actual output from git commands that can be translated.  When running
 706# under GETTEXT_POISON this pretends that the command produced expected
 707# results.
 708test_i18ncmp () {
 709        test -n "$GETTEXT_POISON" || test_cmp "$@"
 710}
 711
 712# Use this instead of "grep expected-string actual" to see if the
 713# output from a git command that can be translated either contains an
 714# expected string, or does not contain an unwanted one.  When running
 715# under GETTEXT_POISON this pretends that the command produced expected
 716# results.
 717test_i18ngrep () {
 718        if test -n "$GETTEXT_POISON"
 719        then
 720            : # pretend success
 721        elif test "x!" = "x$1"
 722        then
 723                shift
 724                ! grep "$@"
 725        else
 726                grep "$@"
 727        fi
 728}
 729
 730test_lazy_prereq PIPE '
 731        # test whether the filesystem supports FIFOs
 732        rm -f testfifo && mkfifo testfifo
 733'
 734
 735test_lazy_prereq SYMLINKS '
 736        # test whether the filesystem supports symbolic links
 737        ln -s x y && test -h y
 738'
 739
 740test_lazy_prereq CASE_INSENSITIVE_FS '
 741        echo good >CamelCase &&
 742        echo bad >camelcase &&
 743        test "$(cat CamelCase)" != good
 744'
 745
 746test_lazy_prereq UTF8_NFD_TO_NFC '
 747        # check whether FS converts nfd unicode to nfc
 748        auml=$(printf "\303\244")
 749        aumlcdiar=$(printf "\141\314\210")
 750        >"$auml" &&
 751        case "$(echo *)" in
 752        "$aumlcdiar")
 753                true ;;
 754        *)
 755                false ;;
 756        esac
 757'
 758
 759test_lazy_prereq AUTOIDENT '
 760        sane_unset GIT_AUTHOR_NAME &&
 761        sane_unset GIT_AUTHOR_EMAIL &&
 762        git var GIT_AUTHOR_IDENT
 763'
 764
 765# When the tests are run as root, permission tests will report that
 766# things are writable when they shouldn't be.
 767test -w / || test_set_prereq SANITY
 768
 769GIT_UNZIP=${GIT_UNZIP:-unzip}
 770test_lazy_prereq UNZIP '
 771        "$GIT_UNZIP" -v
 772        test $? -ne 127
 773'